"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.UnspecifiedForgerError = exports.ForgingMismatchError = void 0;
const core_1 = require("@taquito/core");
/**
 *  @category Error
 *  @description Error that indicates CompositeForger.forge() results doesn't match each other
 */
class ForgingMismatchError extends core_1.TaquitoError {
    constructor(results) {
        super();
        this.results = results;
        this.name = 'ForgingMismatchError';
        this.message = `Forging mismatch error`;
    }
}
exports.ForgingMismatchError = ForgingMismatchError;
/**
 *  @category Error
 *  @description Error that indicates no forger has been configured for CompositeForger
 */
class UnspecifiedForgerError extends core_1.TezosToolkitConfigError {
    constructor() {
        super();
        this.name = 'UnspecifiedForgerError';
        this.message =
            'No forger has been configured. Please configure new CompositeForger([rpcForger, localForger]) with your TezosToolkit instance.';
    }
}
exports.UnspecifiedForgerError = UnspecifiedForgerError;
