"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.UnconfiguredGlobalConstantsProviderError = exports.GlobalConstantNotFound = void 0;
const core_1 = require("@taquito/core");
/**
 *  @category Error
 *  @description Error that indicates that a global constant does not exist
 */
class GlobalConstantNotFound extends core_1.TaquitoError {
    constructor(hash) {
        super();
        this.hash = hash;
        this.name = 'GlobalConstantNotFound';
        this.message = `Please load the value associated with the constant ${hash} using the loadGlobalConstant method of the DefaultGlobalConstantsProvider.`;
    }
}
exports.GlobalConstantNotFound = GlobalConstantNotFound;
/**
 *  @category Error
 *  @description Error that indicates the global constant provider not being configured under TezosToolkit
 */
class UnconfiguredGlobalConstantsProviderError extends core_1.TezosToolkitConfigError {
    constructor() {
        super();
        this.name = 'UnconfiguredGlobalConstantsProviderError';
        this.message =
            'No global constants provider has been configured. Please configure one by calling setGlobalConstantsProvider({globalConstantsProvider}) on your TezosToolkit instance.';
    }
}
exports.UnconfiguredGlobalConstantsProviderError = UnconfiguredGlobalConstantsProviderError;
