"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.UnconfiguredSignerError = void 0;
const core_1 = require("@taquito/core");
/**
 *  @category Error
 *  @description Error that indicates no signer has been configured in the TezosToolkit instance
 */
class UnconfiguredSignerError extends core_1.TezosToolkitConfigError {
    constructor() {
        super();
        this.name = 'UnconfiguredSignerError';
        this.message =
            'No signer has been configured. Please configure one by calling setProvider({signer}) on your TezosToolkit instance.';
    }
}
exports.UnconfiguredSignerError = UnconfiguredSignerError;
