"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.createObservableFromSubscription = void 0;
const rxjs_1 = require("rxjs");
function createObservableFromSubscription(sub) {
    return new rxjs_1.Observable((subscriber) => {
        sub.on('data', (data) => {
            subscriber.next(data);
        });
        sub.on('error', (error) => {
            subscriber.error(error);
        });
        sub.on('close', () => {
            subscriber.complete();
        });
        return () => {
            sub.close();
        };
    });
}
exports.createObservableFromSubscription = createObservableFromSubscription;
