"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ObservableError = exports.ConfirmationUndefinedError = void 0;
const core_1 = require("@taquito/core");
/**
 *  @category Error
 *  @description Error that indicates undefined confirmation has not been specified or configured
 */
class ConfirmationUndefinedError extends core_1.TezosToolkitConfigError {
    constructor() {
        super();
        this.name = 'ConfirmationUndefinedError';
        this.message = 'Default confirmation count can not be undefined';
    }
}
exports.ConfirmationUndefinedError = ConfirmationUndefinedError;
/**
 *  @category Error
 *  @description Error that indicates a generic failure when trying to fetch an observable
 */
class ObservableError extends core_1.NetworkError {
    constructor(message) {
        super();
        this.message = message;
        this.name = 'ObservableError';
    }
}
exports.ObservableError = ObservableError;
