export declare const DEFAULT_GAS_LIMIT: {
    DELEGATION: number;
    ORIGINATION: number;
    TRANSFER: number;
    REVEAL_TZ1: number;
    REVEAL_TZ2: number;
    REVEAL_TZ3: number;
    REVEAL_TZ4: number;
};
export declare const DEFAULT_FEE: {
    DELEGATION: number;
    ORIGINATION: number;
    TRANSFER: number;
    REVEAL: number;
};
export declare const DEFAULT_STORAGE_LIMIT: {
    DELEGATION: number;
    ORIGINATION: number;
    TRANSFER: number;
    REVEAL: number;
};
export declare const COST_PER_BYTE = 250;
export declare enum Protocols {
    Pt24m4xi = "Pt24m4xiPbLDhVgVfABUjirbmda3yohdN82Sp9FeuAXJ4eV9otd",
    PsBABY5H = "PsBABY5HQTSkA4297zNHfsZNKtxULfL18y95qb3m53QJiXGmrbU",
    PsBabyM1 = "PsBabyM1eUXZseaJdmXFApDSBqj8YBfwELoxZHHW77EMcAbbwAS",
    PsCARTHA = "PsCARTHAGazKbHtnKfLzQg3kms52kSRpgnDY982a9oYsSXRLQEb",
    PsDELPH1 = "PsDELPH1Kxsxt8f9eWbxQeRxkjfbxoqM52jvs5Y5fBxWWh4ifpo",
    PtEdo2Zk = "PtEdo2ZkT9oKpimTah6x2embF25oss54njMuPzkJTEi5RqfdZFA",
    PsFLorena = "PsFLorenaUUuikDWvMDr6fGBRG8kt3e3D3fHoXK1j1BFRxeSH4i",
    PtGRANADs = "PtGRANADsDU8R9daYKAgWnQYAJ64omN1o3KMGVCykShA97vQbvV",
    PtHangz2 = "PtHangz2aRngywmSRGGvrcTyMbbdpWdpFKuS4uMWxg2RaH9i1qx",
    PsiThaCa = "PsiThaCaT47Zboaw71QWScM8sXeMM7bbQFncK9FLqYc6EKdpjVP",
    Psithaca2 = "Psithaca2MLRFYargivpo7YvUr7wUDqyxrdhC5CQq78mRvimz6A",
    PtJakart2 = "PtJakart2xVj7pYXJBXrqHgd82rdkLey5ZeeGwDgPp9rhQUbSqY",
    PtKathman = "PtKathmankSpLLDALzWw7CGD2j2MtyveTwboEYokqUCP4a1LxMg",
    PtLimaPtL = "PtLimaPtLMwfNinJi9rCfDPWea8dFgTZ1MeJ9f1m2SRic6ayiwW",
    PtMumbaii = "PtMumbaiiFFEGbew1rRjzSPyzRbA51Tm3RVZL5suHPxSZYDhCEc",
    PtMumbai2 = "PtMumbai2TmsJHNGRkD8v8YDbtao7BLUC3wjASn1inAKLFCjaH1",
    PtNairobi = "PtNairobiyssHuh87hEhfVBGCVrK3WnS8Z2FT4ymB5tAa4r1nQf",
    ProtoALpha = "ProtoALphaALphaALphaALphaALphaALphaALphaALphaDdp3zK"
}
export declare const protocols: {
    '004': Protocols[];
    '005': Protocols[];
    '006': Protocols[];
    '007': Protocols[];
    '008': Protocols[];
    '009': Protocols[];
    '010': Protocols[];
    '011': Protocols[];
    '012': Protocols[];
    '013': Protocols[];
    '014': Protocols[];
    '015': Protocols[];
    '016': Protocols[];
    '017': Protocols[];
    '018': Protocols[];
};
export declare enum ChainIds {
    MAINNET = "NetXdQprcVkpaWU",
    CARTHAGENET = "NetXjD3HPJJjmcd",
    DELPHINET = "NetXm8tYqnMWky1",
    EDONET = "NetXSgo1ZT2DRUG",
    FLORENCENET = "NetXxkAx4woPLyu",
    GRANADANET = "NetXz969SFaFn8k",
    HANGZHOUNET = "NetXZSsxBpMQeAT",
    ITHACANET = "NetXbhmtAbMukLc",
    ITHACANET2 = "NetXnHfVqm9iesp",
    JAKARTANET2 = "NetXLH1uAxK7CCh",
    KATHMANDUNET = "NetXazhm4yetmff",
    LIMANET = "NetXizpkH94bocH",
    MUMBAINET = "NetXQw6nWSnrJ5t",
    MUMBAINET2 = "NetXgbcrNtXD2yA",
    NAIROBINET = "NetXyuzvDo2Ugzb"
}
export declare const getRevealGasLimit: (address: string) => number;
