import { ParameterValidationError, RpcError, NetworkError } from '@taquito/core';
/**
 *  @category Error
 *  @description Error that indicates invalid confirmation count has been passed or configured
 */
export declare class InvalidConfirmationCountError extends ParameterValidationError {
    readonly invalidConfirmations: number;
    constructor(invalidConfirmations: number);
}
/**
 *  @category Error
 *  @description Error that indicates that confirmation polling timed out
 */
export declare class ConfirmationTimeoutError extends NetworkError {
    readonly message: string;
    constructor(message: string);
}
/**
 *  @category Error
 *  @description Error that indicates an error being returned from the RPC response
 */
export declare class RPCResponseError extends RpcError {
    readonly message: string;
    readonly cause?: any;
    constructor(message: string, cause?: any);
}
