import { GlobalConstantHashAndValue } from '@taquito/michel-codec';
import { GlobalConstantHash, GlobalConstantsProvider } from './interface-global-constants-provider';
export declare class DefaultGlobalConstantsProvider implements GlobalConstantsProvider {
    private _globalConstantsLibrary;
    /**
     *
     * @description Allows to load global constant hashes and their corresponding Michelson JSON values
     */
    loadGlobalConstant(globalConstant: GlobalConstantHashAndValue): void;
    /**
     *
     * @description Retrieve the Michelson value of a global constant based on its hash
     *
     * @param hash a string representing the global constant hash
     * @returns Expr, the JSON Michelson value
     */
    getGlobalConstantByHash(hash: GlobalConstantHash): Promise<import("@taquito/michel-codec").Expr>;
}
