import { OperationContents, OperationContentsAndResult } from '@taquito/rpc';
import { Context } from '../context';
import { Operation } from './operations';
import { FeeConsumingOperation, ForgedBytes, GasConsumingOperation, StorageConsumingOperation } from './types';
export declare class BatchOperation extends Operation implements GasConsumingOperation, StorageConsumingOperation, FeeConsumingOperation {
    private readonly params;
    readonly source: string;
    constructor(hash: string, params: OperationContents[], source: string, raw: ForgedBytes, results: OperationContentsAndResult[], context: Context);
    private sumProp;
    getOriginatedContractAddresses(): string[];
    get status(): import("@taquito/rpc").OperationResultStatusEnum | "unknown";
    get fee(): any;
    get gasLimit(): any;
    get storageLimit(): any;
    get consumedGas(): string;
    get consumedMilliGas(): string;
    get storageDiff(): string;
    get errors(): import("@taquito/rpc").TezosGenericOperationError[];
}
