import { OperationContentsAndResult, OperationContentsAndResultProposals, OperationContentsProposals } from '@taquito/rpc';
import { Context } from '../context';
import { Operation } from './operations';
import { ForgedBytes } from './types';
/**
 *
 * @description ProposalsOperation provides utility functions to fetch a new operation of kind proposals
 *
 */
export declare class ProposalsOperation extends Operation {
    private readonly params;
    readonly source: string;
    constructor(hash: string, params: OperationContentsProposals, source: string, raw: ForgedBytes, results: OperationContentsAndResult[], context: Context);
    get operationResults(): OperationContentsAndResultProposals | undefined;
    get proposals(): string[];
    get period(): number | undefined;
}
