import { OperationContentsAndResult, OperationContentsSmartRollupAddMessages } from '@taquito/rpc';
import { Context } from '../context';
import { Operation } from './operations';
import { FeeConsumingOperation, ForgedBytes, GasConsumingOperation, StorageConsumingOperation } from './types';
/**
 * @description SmartRollupAddMessagesOperation provides utility to fetch properties of SmartRollupAddMessages
 */
export declare class SmartRollupAddMessagesOperation extends Operation implements GasConsumingOperation, StorageConsumingOperation, FeeConsumingOperation {
    private readonly params;
    readonly source: string;
    constructor(hash: string, params: OperationContentsSmartRollupAddMessages, source: string, raw: ForgedBytes, results: OperationContentsAndResult[], context: Context);
    get operationResults(): import("@taquito/rpc").OperationResultSmartRollupAddMessages | undefined;
    get status(): import("@taquito/rpc").OperationResultStatusEnum | "unknown";
    get message(): string[];
    get fee(): number;
    get gasLimit(): number;
    get storageLimit(): number;
    get consumedMilliGas(): string | undefined;
    get errors(): import("@taquito/rpc").TezosGenericOperationError[] | undefined;
}
