import { OperationContentsAndResult, OperationContentsSmartRollupOriginate } from '@taquito/rpc';
import { Context } from '../context';
import { Operation } from './operations';
import { FeeConsumingOperation, ForgedBytes, GasConsumingOperation, StorageConsumingOperation } from './types';
/**
 *
 * @description SmartRollupOriginate Operation provides utility to fetch properties for Operation of kind SmartRollupOriginate
 *
 */
export declare class SmartRollupOriginateOperation extends Operation implements GasConsumingOperation, StorageConsumingOperation, FeeConsumingOperation {
    private readonly params;
    readonly source: string;
    constructor(hash: string, params: OperationContentsSmartRollupOriginate, source: string, raw: ForgedBytes, results: OperationContentsAndResult[], context: Context);
    get operationResults(): import("@taquito/rpc").OperationResultSmartRollupOriginate | undefined;
    get status(): import("@taquito/rpc").OperationResultStatusEnum | "unknown";
    get fee(): number;
    get gasLimit(): number;
    get storageLimit(): number;
    get consumedMilliGas(): string | undefined;
    get pvmKind(): import("@taquito/rpc").PvmKind;
    get kernel(): string;
    get originationProof(): string;
    get errors(): import("@taquito/rpc").TezosGenericOperationError[] | undefined;
}
