import { OperationContentsAndResult } from '@taquito/rpc';
import { Context } from '../context';
import { Operation } from './operations';
import { FeeConsumingOperation, ForgedBytes, GasConsumingOperation, RPCTxRollupBatchOperation, StorageConsumingOperation } from './types';
/**
 * @description TxRollupBatchOperation provides utility functions to fetch a newly issued operation of kind tx_rollup_submit_batch
 */
export declare class TxRollupBatchOperation extends Operation implements GasConsumingOperation, StorageConsumingOperation, FeeConsumingOperation {
    private readonly params;
    readonly source: string;
    constructor(hash: string, params: RPCTxRollupBatchOperation, source: string, raw: ForgedBytes, results: OperationContentsAndResult[], context: Context);
    get operationResults(): import("@taquito/rpc").OperationResultTxRollupSubmitBatch | undefined;
    get status(): import("@taquito/rpc").OperationResultStatusEnum | "unknown";
    get content(): string;
    get fee(): number;
    get gasLimit(): number;
    get storageLimit(): number;
    get errors(): import("@taquito/rpc").TezosGenericOperationError[] | undefined;
    get consumedGas(): string | undefined;
    get consumedMilliGas(): string | undefined;
}
