import { OperationContentsAndResult } from '@taquito/rpc';
import { Context } from '../context';
import { Operation } from './operations';
import { FeeConsumingOperation, ForgedBytes, GasConsumingOperation, RPCTxRollupOriginationOperation, StorageConsumingOperation } from './types';
/**
 * @description TxRollupOriginationOperation provides utility functions to fetch a newly issued operation of kind tx_rollup_origination
 */
export declare class TxRollupOriginationOperation extends Operation implements GasConsumingOperation, StorageConsumingOperation, FeeConsumingOperation {
    private readonly params;
    readonly source: string;
    /**
     * @description Address the newly originate rollup
     */
    readonly originatedRollup?: string;
    constructor(hash: string, params: RPCTxRollupOriginationOperation, source: string, raw: ForgedBytes, results: OperationContentsAndResult[], context: Context);
    get operationResults(): import("@taquito/rpc").OperationResultTxRollupOrigination | undefined;
    get status(): import("@taquito/rpc").OperationResultStatusEnum | "unknown";
    get fee(): number;
    get gasLimit(): number;
    get storageLimit(): number;
    get errors(): import("@taquito/rpc").TezosGenericOperationError[] | undefined;
    get consumedGas(): string | undefined;
    get consumedMilliGas(): string | undefined;
}
