import { ParameterValidationError } from '@taquito/core';
import { FilterExpression } from '../taquito';
/**
 *  @category Error
 *  @description Error that indicates an unsupported event being passed or used
 */
export declare class UnsupportedEventError extends ParameterValidationError {
    readonly type: string;
    constructor(type: string);
}
/**
 *  @category Error
 *  @description Error that indicates an invalid filter expression being passed or used
 */
export declare class InvalidFilterExpressionError extends ParameterValidationError {
    readonly invalidExpression: FilterExpression;
    constructor(invalidExpression: FilterExpression);
}
